<?php
/**
 * SphiderLITE Version 2.6.*
 * Sphider is licensed under the GNU GPL.
 *
 * PHP version 5.4
 *
 * @category Sphider_Search
 * @package  Installation
 * @author   R. Prew  <CaptQ@blog.worldspaceflight.com>
 * @license  GNU GPL
 * @link     http://www.sphidersearch.com
 */
echo "<html>";
echo "<head>";
echo "<title>";
echo "Update version number to 2.5.0.";
echo "</title>";
echo "<LINK REL=STYLESHEET HREF='admin.css' TYPE='text/css'>";
echo "</head>";
echo "<body>";
echo "<h2>Update the database version number.</h2>";

//error_reporting(E_ERROR | E_DEPRECATED); //Development only
error_reporting(0);
$settings_dir = "../settings";
require "$settings_dir/database.php";

$error = 0;
$flag = 0;

/**
 * Update to version 1.1.0
 *
 * @return void
 */
function update110()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='1.1.0'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "1.1.0";
}

/**
 * Update to version 1.1.1
 *
 * @return void
 */
function update111()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='1.1.1'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "1.1.1";
}

/**
 * Update to version 1.1.2
 *
 * @return void
 */
function update112()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='1.1.2'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "1.1.2";
}

/**
 * Update to version 1.1.3
 *
 * @return void
 */
function update113()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='1.1.3'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "1.1.3";
}

/**
 * Update to version 1.1.4
 *
 * @return void
 */
function update114()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='1.1.4'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "1.1.4";
}

/**
 * Update to version 1.1.5
 *
 * @return void
 */
function update115()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='1.1.5'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "1.1.5";
}

/**
 * Update to version 1.2.0
 *
 * @return void
 */
function update120()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='1.2.0'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "1.2.0";
}

/**
 * Update to version 1.2.1
 *
 * @return void
 */
function update121()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='1.2.1'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "1.2.1";
}

/**
 * Update to version 1.2.2
 *
 * @return void
 */
function update122()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='1.2.2'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "1.2.2";
}

/**
 * Update to version 1.2.3
 *
 * @return void
 */
function update123()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='1.2.3'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "1.2.3";
}

/**
 * Update to version 1.3.0
 *
 * @return void
 */
function update130()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='1.3.0'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "1.3.0";
}

/**
 * Update to version 1.3.1
 *
 * @return void
 */
function update131()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='1.3.1'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "1.3.1";
}

/**
 * Update to version 1.3.2
 *
 * @return void
 */
function update132()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='1.3.2'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "1.3.2";
}

/**
 * Update to version 2.0.0
 *
 * @return void
 */
function update200()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Create temp2 table
    $db->query(
        "CREATE TABLE ".$mysql_table_prefix."temp2 (
        link varchar(255),
        id varchar (32)
        ) ENGINE = InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci"
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='2.0.0'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "2.0.0";
}

/**
 * Update to version 2.0.1
 *
 * @return void
 */
function update201()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='2.0.1'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "2.0.1";
}

/**
 * Update to version 2.0.2
 *
 * @return void
 */
function update202()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='2.0.2'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "2.0.2";
}

/**
 * Update to version 2.1.0
 *
 * @return void
 */
function update210()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Drop temp2 table
    $db->query(
        "DROP TABLE ".$mysql_table_prefix."temp2"
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='2.1.0'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "2.1.0";
}

/**
 * Update to version 2.2.0
 *
 * @return void
 */
function update220()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Modify description in links table
    $db->query(
        "ALTER TABLE ".$mysql_table_prefix."links
        MODIFY COLUMN description text"
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='2.2.0'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "2.2.0";
}

/**
 * Update to version 2.2.1
 *
 * @return void
 */
function update221()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='2.2.1'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "2.2.1";
}

/**
 * Update to version 2.3.0
 *
 * @return void
 */
function update230()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='2.3.0',
        user_agent='Sphider (sphidersearch.com)'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "2.3.0";
}

/**
 * Update to version 2.3.1
 *
 * @return void
 */
function update231()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='2.3.1',
        user_agent='Sphider (sphidersearch.com)'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "2.3.1";
}

/**
 * Update to version 2.4.0
 *
 * @return void
 */
function update240()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='2.4.0',
        user_agent='Sphider (sphidersearch.com)'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "2.4.0";
}

/**
 * Update to version 2.5.0
 *
 * @return void
 */
function update250()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Create new column pandoc_path in settings table
    $db->query(
        "ALTER TABLE ".$mysql_table_prefix
        ."settings ADD COLUMN pandoc_path VARCHAR(45) NULL DEFAULT NULL
        AFTER catppt_path"
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    // Create new column pause_ in settings table
    $db->query(
        "ALTER TABLE ".$mysql_table_prefix
        ."settings ADD COLUMN pause_ INT NULL DEFAULT NULL
        AFTER min_delay"
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    // Create new column pause_time in settings table
    $db->query(
        "ALTER TABLE ".$mysql_table_prefix
        ."settings ADD COLUMN pause_time INT NULL DEFAULT NULL
        AFTER pause_"
    );
    
    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    // Create new column pause_time in settings table
    $db->query(
        "ALTER TABLE ".$mysql_table_prefix
        ."settings ADD COLUMN pause_pages INT NULL DEFAULT NULL
        AFTER pause_time"
    );
    
    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    // Create new column cft_lang in sites table
    $db->query(
        "ALTER TABLE ".$mysql_table_prefix
        ."sites ADD COLUMN ct_lang VARCHAR(10) NOT NULL DEFAULT 'en'
        AFTER can_leave_domain"
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    // Insert initial settings into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='2.5.0',
        pandoc_path='/usr/bin/pandoc',
        pause_='0',
        pause_time='120',
        pause_pages='30'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "2.5.0";
}

/**
 * Update to version 2.6.0
 *
 * @return void
 */
function update260()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Change column 'language' to 'slanguage'
    $db->query(
        "ALTER TABLE ".$mysql_table_prefix
        ."settings CHANGE COLUMN language slanguage VARCHAR(5) NULL DEFAULT NULL"
    );
    
    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    
    // Create new column dec_separator in settings table
    $db->query(
        "ALTER TABLE ".$mysql_table_prefix
        ."settings ADD COLUMN dec_separator VARCHAR(2) NULL DEFAULT NULL
        AFTER index_decimals"
    );
    
    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    // Insert initial settings into settings table
    // Restore defaults on possible corrupted settings
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='2.6.0',
        dec_separator='.',
        cat_columns='2',
        bound_search_result='0',
        length_of_link_desc='0',
        links_to_next='9'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "2.6.0";
}


$state = 0;
$result = $db->query("SHOW TABLES LIKE '%settings'");
if ($result->num_rows < 1) {
    $state = 1;
} else {
    $result = $db->query(
        "SELECT version_nr FROM ".$mysql_table_prefix
        ."settings WHERE id = 1"
    );
    $row = $result->fetch_row();
    if (is_null($row[0])) {
        $row[0] = "";
    }
    if (preg_match('/1\.0\.0/', $row[0])) {
        $state = 2;
    } elseif (preg_match('/1\.1\.0/', $row[0])) { 
        $state = 3;
    } elseif (preg_match('/1\.1\.1/', $row[0])) { 
        $state = 4;
    } elseif (preg_match('/1\.1\.2/', $row[0])) { 
        $state = 5;
    } elseif (preg_match('/1\.1\.3/', $row[0])) { 
        $state = 6;
    } elseif (preg_match('/1\.1\.4/', $row[0])) { 
        $state = 7;
    } elseif (preg_match('/1\.1\.5/', $row[0])) { 
        $state = 8;
    } elseif (preg_match('/1\.2\.0/', $row[0])) { 
        $state = 9;
    } elseif (preg_match('/1\.2\.1/', $row[0])) { 
        $state = 10;
    } elseif (preg_match('/1\.2\.2/', $row[0])) { 
        $state = 11;
    } elseif (preg_match('/1\.2\.3/', $row[0])) { 
        $state = 12;
    } elseif (preg_match('/1\.3\.0/', $row[0])) { 
        $state = 13;
    } elseif (preg_match('/1\.3\.1/', $row[0])) { 
        $state = 14;
    } elseif (preg_match('/1\.3\.2/', $row[0])) { 
        $state = 15;
    } elseif (preg_match('/2\.0\.0/', $row[0])) { 
        $state = 16;
    } elseif (preg_match('/2\.0\.1/', $row[0])) { 
        $state = 17;
    } elseif (preg_match('/2\.0\.2/', $row[0])) { 
        $state = 18;
    } elseif (preg_match('/2\.1\.0/', $row[0])) { 
        $state = 19;
    } elseif (preg_match('/2\.2\.0/', $row[0])) { 
        $state = 20;
    } elseif (preg_match('/2\.2\.1/', $row[0])) { 
        $state = 21;
    } elseif (preg_match('/2\.3\.0/', $row[0])) { 
        $state = 22;
    } elseif (preg_match('/2\.3\.1/', $row[0])) { 
        $state = 23;
    } elseif (preg_match('/2\.4\.0/', $row[0])) { 
        $state = 24;
    } elseif (preg_match('/2\.5\.0/', $row[0])) { 
        $state = 25;
    } elseif (preg_match('/2\.6\.0/', $row[0])) { 
        $state = 26;
    } else { 
        $state = 99; 
    }
}

switch ($state) {
case 0:
case 1:
    echo "Unknown Sphider version.<br>A clean install is suggested.<br>";
    exit;
case 2:
    update110();
case 3:
    update111();
case 4:
    update112();
case 5:
    update113();
case 6:
    update114();
case 7:
    update115();
case 8:
    update120();
case 9:
    update121();
case 10:
    update122();
case 11:
    update123();
case 12:
    update130();
case 13:
    update131();
case 14:
    update132();
case 15:
    update200();
case 16:
    update201();
case 17:
    update202();
case 18:
    update210();
case 19:
    update220();
case 20:
    update221();
case 21:
    update230();
case 22:
    update231();
case 23:
    update240();
case 24:
    update250();
case 25:
    update260();
    break;
case 99;
    echo "You do not have a SphiderLite version installed.";
    exit;
default:
    echo "You already have the latest version installed<br>";
    $flag = 1;
}

if ($error >0) {
    print "<b>Updating the database failed. Consult the above error messages.</b>";
} else {
    if (!$flag) {
        print "<b>You have successfully updated the database to version ".$ver
          .". Go to <a href='admin.php'>admin.php</a> to start indexing.</b>"; 
    }
}

echo "</body>";
echo "</html>";
