<?php
/**
 * SphiderLite Version 1.0.*
 * Sphider is licensed under the GNU GPL.
 *
 * PHP version 5.4
 *
 * @category Sphider_Search
 * @package  Search
 * @author   R. Prew  <CaptQ@blog.worldspaceflight.com>
 * @license  GNU GPL
 * @link     http://www.sphidersearch.com
 */
if ($catid && is_numeric($catid)) {
    // category tree
    echo "<br>";
    echo "<div class='main_cat1'>";
    echo "<a href='search.php'>".$sph_messages['Categories']."</a> >";
    foreach ($cat_info['cat_tree'] as $_val) {
        echo "<a href='?catid=".$_val['category_id']."'>"
          .$_val['category']."</a> >";
    }
    echo "</div>";
    // list of sub-categories
    if ($cat_info['subcats']) {
        echo "<div class='catBanner'>".$sph_messages['Categories']."</div><br>";
        foreach ($cat_info['subcats'] as $_key => $_val) {
            echo "<a href='?catid=".$_val['category_id']."'><b>".$_val['category']
              ."</b></a> (".$_val['count'][0][0].")<br>";
        }
    }

    // list of category web pages
    if ($cat_info['cat_sites']) {
        echo "<div class='webPageBanner'>".$sph_messages['Web pages']
          ."</div><br>";
        foreach ($cat_info['cat_sites'] as $_key => $_val) {
            echo "<b>".($_key + 1).".</b> <a href='".$_val['url']."'><b>"
              .$_val['title']."</b></a><br>".$_val['short_desc']
              ."<br><font class='url'>".$_val['url']."</font><br><br>";
        }
    }
    echo "<div class='divline'>";
    echo "</div>";

} else {
    // category selection
    if ($cat_info['main_list']) {
        echo "<br>";
        echo "<div style='text-align:center;' id='cat_main'>";
        echo $sph_messages['CATEGORIES'];
        echo "</div>";
        echo "<div style='width:40%; margin:0px auto; padding:4px; border:none;
          display:table;'>";
        echo "<div class='row'>";
        foreach ($cat_info['main_list'] as $_key => $_val) {
            $col_width=100/$cat_columns;
            echo "<div class='left' style='width:".$col_width."%;'>";
            echo "<a href='?catid=".$_val['category_id']."' class='main_cat1'>"
              .$_val['category']."</a><br>&nbsp;&nbsp;";
            if (is_array($_val['sub'])) {
                foreach ($_val['sub'] as $__key => $__val) {
                    // only 3 subcategories
                    if ($__key > 2) {
                        break;
                    }
                    echo "<a href='?catid=".$__val['category_id']
                      ."' class='main_cat2'>".$__val['category']."</a> ";
                }
            }
            echo "</div>";
            // column nr defined in config
            if (!(($_key +1)% $cat_columns)) {
                echo "</div><div class='row'>";
            }
        }
        echo "</div>";
        echo "</div>";
    }
}

echo "<div id='powered_by'>";
poweredBy();
echo "</div>";
