<?php
/**
 * SphiderLite Version 2.2.*
 * Sphider is licensed under the GNU GPL.
 *
 * PHP version 5.4
 *
 * @category Sphider_Search
 * @package  Search
 * @author   R. Prew  <CaptQ@blog.worldspaceflight.com>
 * @license  GNU GPL
 * @link     http://www.sphidersearch.com
 */
echo "<div class='container'>
  <br>
  <form action='search.php' method='get'>
  <input type='text' name='query' id='keyword' size='40' value='"
  .htmlentities($query ?? '', ENT_QUOTES, 'UTF-8')
  ."' autocomplete='off'>
  <div id='sresults'></div>
  <input type='submit' class='button' value='"
  .$sph_messages['Search']
    ."'><br><br>";
if ($adv==1 || $advanced_search==1) {
    echo "<div class='advanced'>
      <div class='left'>";
    echo "<input type='radio' name='type' value='and' ";
    echo strip_tags($type ?? '')=='and'?'checked':'';
    echo ">"
      .$sph_messages['andSearch']
      ."<br><br>";
    echo "<input type='radio' name='type' value='phrase' ";
    echo strip_tags($_REQUEST['type'] ?? '')=='phrase'?'checked':'';
    echo ">"
      .$sph_messages['phraseSearch']
      ."</div>
      <div class='right'>";
    echo "<input type='radio' name='type' value='or' ";
    echo strip_tags($_REQUEST['type'] ?? '')=='or'?'checked':'';
    echo ">"
      .$sph_messages['orSearch']
      ."<br><br>"
      .$sph_messages['show']
      ."<select name='results'>
      <option ";
    if ($results_per_page==10) { 
        echo "selected"; 
    }
    echo ">10</option>
      <option ";
    if ($results_per_page==20) {
        echo "selected"; 
    }
    echo ">20</option>
      <option ";
    if ($results_per_page==50) { 
        echo "selected"; 
    }
    echo ">50</option>
      <option ";
    if ($results_per_page==100) { 
        echo "selected"; 
    }
    echo ">100</option>
      </select>"
      .$sph_messages['resultsPerPage']
      ."</div>
      </div>";
    if ($catid == 0 || $catid == "") {
        $stmt = $db->prepare(
            "SELECT domain FROM `".$mysql_table_prefix
            ."domains` ORDER BY domain"
        );
        if ($stmt) {
            $stmt->execute() or die("Execution failed: ".$stmt->error);
            $stmt->bind_result($rdomain);
            $stmt->store_result();
            $num_domains=$stmt->num_rows;
            if ($num_domains > 1) {
                echo "<br>
                <div style='text-align: center'>";
                echo "<b>".$sph_messages['SearchIn']."</b>: ";
                echo "<select name='domain'>";
                echo "<option value=''>All domains </option>";
                while ($stmt->fetch()) {
                    echo "<option value='".$rdomain."'>".$rdomain
                      ." </option>";
                }
                echo "</select></div>";
            }
            $stmt->close();
        } else {
            trigger_error('Statement failed : '.$db->error, E_USER_ERROR);
        }
    }
}

if ($catid<>0 && $show_categories) {
    echo "<br><div style='text-align:center;'><b>";
    echo $sph_messages['Search'];
    echo "</b>: <input type='radio' name='category' value='"
      .$catid
      ."' checked>";
    echo $sph_messages['Only in category'];
    echo " '";
    echo $tpl_['category'][0]['category'];
    echo "'' <input type='radio' name='category' value=''>"
      .$sph_messages['All sites']
      ."</div>";
}
    echo "<input type='hidden' name='search' value='1'>
      <input type='hidden' name='s' value='1'>
      </form><br>
      </div>";
if ($has_categories && $search==1 && $show_categories) {
    echo "<a href='search.php'>"
      .$sph_messages['Categories']
      ."</a>";
}
